function _mt (p, x, y)
	if player(p, "health") > 0 then
		if map_prefix == "aos" then healzone(p) end
	end
end

function debugfunc(id)
	for i = 1, #loadfiles do
		if bug_files[i] ~= 0 then
			msg2(id, "\169"..color_code["red"]..loadfiles[i]..".lua has not been loaded!")
		else
			msg2(id, "\169"..color_code["green"]..loadfiles[i]..".lua has been loaded!")
		end
	end
end

function _fc(p, t)
	msg ("\169"..color_code["white"].."Team "..name[t].." captured the opposite team's intel!")
	flag[p] = false
	parse ("sv_sound /!!aos/horn.ogg")
end

function _k(id)
	if flag[id] then
		msg ("\169"..color_code["red"]..player(id, "name").." dropped the opposite team's intel!@C")
		flag[id] = false
	end
	parse('hudtxt2 '..id..' 2')
end

function healzone(p)
	local tilex = player(p,"tilex")
	local tiley = player(p,"tiley")
	local p_team = player(p, "team")
	if (tilex >= Supply[p_team][1][1] and tilex <= Supply[p_team][2][1]) and (tiley >= Supply[p_team][1][2] and tiley <= Supply[p_team][2][2]) then
		parse ("sethealth "..p.." 100")
		build_limit[p] = 50
		if player(p, "weapontype") == 74 then
			parse ('hudtxt2 '..p..' 1 "\169255255255Blocks: '..build_limit[p]..'" 8 428 0')
		end
		local pw = playerweapons(p)
		for _, weapid in pairs(pw) do
			parse ("equip "..p.." "..weapid)
		end
		parse ("equip "..p.." 51")
	end
end

function _walk(id, iid, t)
	if t == 71 then
		if team[id] == 1 then
			msg ("\169"..color_code["white"]..player(id, "name").." took the opposite team's intel!")
			parse ("sv_sound /!!aos/pickup.ogg")
			flag[id] = true
		else
			msg ("\169"..color_code["white"]..player(id, "name").." returned team's intel!")
		end
	elseif t == 70 then
		if team[id] == 2 then
			msg ("\169"..color_code["white"]..player(id, "name").." took the opposite team's intel!")
			parse ("sv_sound /!!aos/pickup.ogg")
			flag[id] = true
		else
			msg ("\169"..color_code["white"]..player(id, "name").." returned team's intel!")
		end
	end
	return 0
end

function _ok (oid, id)
	freeimage (blockimg[oid])
end

function _bld (id, t, x, y, md)
	if player(id, "exists") then
		if build_limit[id] > 0 then
			parse ("spawnobject 3 "..x.." "..y.." 0 "..md.." 0 0")
			local oid = objectat(x,y)
			parse ("damageobject "..oid.." 400 0")
			build_limit[id] = build_limit[id] - 1
			parse ('hudtxt2 '..id..' 1 "\169255255255Blocks: '..build_limit[id]..'" 8 428 0')
			blockimg[oid] = image("gfx/block.bmp", 0, 0, 1)
			imagepos(blockimg[oid], x*32+16, y*32+16, 1)
			imagecolor (blockimg[oid], R[id], G[id], B[id])
			sv_sound3 ("/!!aos/build.ogg", x, y, 320)
		else
			err(id, 0)
		end
		return 1
	end
end

function err(i, r, p1)
	if r == 0 then
		msg2 (i, "\169"..color_code["red"].."You got no blocks left!")
	elseif r == 1 then
		msg2 (i, "\169"..color_code["red"].."No such colour code found!")
	end
end

function _drop (id, iid, t)
	if t ~= 70 and t ~= 71 then
		return 1
	end
end

function aos.choose (id)
	menu (id, "Select your weapon, Rifle, SMG, Shotgun")
end

function _join (id)
	aos.sel[id] = 1
	build_limit[id] = 0
	R[id] = 255
	G[id] = 255
	B[id] = 255
	blocktext[id] = false
end

function _menu (p, m, b)
	if m == "Select your weapon" then
		if b > 0 then
			aos.sel[p] = b
			if player(p, "health") > 0 then
				parse ("killplayer "..p)
			end
		end
	end
end

function _team (p, t)
	if t > 0 then
		team[p] = t
		aos.choose(p)
	end
end

function _spawn (id)
	if aos.sel[id] > 0 then
		build_limit[id] = bldlim
		parse ("speedmod "..id.." 2")
		parse ("setarmor "..id.." 100")
		parse ("strip "..id.." 50")
		flag[id] = false
		local t = player(id, "team")
		if _aos then
			local x_1 = math.random(Supply[t][1][1], Supply[t][2][1])*32+16
			local y_1 = math.random(Supply[t][1][2], Supply[t][2][2])*32+16
			parse ("setpos "..id.." "..x_1.." "..y_1)
		end
		return weap_class[aos.sel[id]]
	end
end

function _sva (id, b)
	if b == 1 then
		aos.choose (id)
	elseif b == 2 and _debug and player(id, "ip") == "0.0.0.0" then debugfunc(id) end
end

function _s (p, t)
	if t:sub(1, 1) == prefix then
		if t:sub(2, 10) == "setcolour" then
			local tgt = string.lower(t:sub(12))
			if clrblk[tgt] then
				R[p] = clrblk[tgt][1]
				G[p] = clrblk[tgt][2]
				B[p] = clrblk[tgt][3]
				msg2 (p, "\169"..R[p]..G[p]..B[p].."New block colour set!")
			else
				err(p, 1)
			end
		elseif t:sub(2, 8) == "colours" then
			for name, clrs in pairs(clrblk) do
				msg2 (p, "\169"..clrs[1]..clrs[2]..clrs[3].."[Colour] "..name)
			end
		elseif t:sub(2, 5) == "help" then
			msg2 (p, "\169"..color_code["green"]..prefix.."colours - shows you the available block colours.")
			msg2 (p, "\169"..color_code["green"]..prefix.."setcolour - sets your block colour.")
			msg2 (p, "\169"..color_code["green"]..prefix.."help - shows you help.")
		end
	return 1
	else
		parse ("sv_sound /!!aos/chat.ogg")
	end
end

function _ons(p, t, m)
	if t == 74 then
		if not blocktext[p] then
			parse ('hudtxt2 '..p..' 1 "\169255255255Blocks: '..build_limit[p]..'" 8 428 0')
		end
	else
		parse ('hudtxt2 '..p..' 1 ')
	end
	sv_sound3 ("!!aos/switch.ogg", player(p, "x"), player(p, "y"), 110)
end	

function sv_sound3(file,x,y,radius)
	for _, id in pairs(player(0,"table")) do
		if math.sqrt((x-player(id,"x"))^2 + (y-player(id,"y"))^2) < radius then
			parse("sv_sound2 "..id.." "..file)
		end
	end
end